//signal.cc: Implementation file for signal.h

#include "signal.h"

voltage_type asserted_high_voltage_value(signal_type signal)
{
  voltage_type value;
  switch (signal)
    {
    case True:
      value = High;
      break;
    case False:
      value = Low;
      break;
    case High_Impedance:
      value = Floating;
      break;
    case Unknown:
    default:
      value = Floating; //unknown
    } //switch
  return value;
} //asserted_high_voltage_value


voltage_type asserted_low_voltage_value(signal_type signal)
{
  voltage_type value;
  switch (signal)
    {
    case True:
      value = Low;
      break;
    case False:
      value = High;
      break;
    case High_Impedance:
      value = Floating;
      break;
    case Unknown:
    default:
      value = Floating; //unknown
    } //switch
  return value;
} //asserted_low_voltage_value


signal_type asserted_high_signal_value(voltage_type voltage)
{
  signal_type value;
  switch (voltage)
    {
    case Low:
      value = False;
      break;
    case High:
      value = True;
      break;
    case Floating:
      value = High_Impedance;
      break;
    default:
      value = Unknown; //unknown
    } //switch
  return value;
} //asserted_high_signal_value


signal_type asserted_low_signal_value(voltage_type voltage)
{
  signal_type value;
  switch (voltage)
    {
    case Low:
      value = True;
      break;
    case High:
      value = False;
      break;
    case Floating:
      value = High_Impedance;
      break;
    default:
      value = Unknown; //unknown
    } //switch
  return value;
} //asserted_low_signal_value


char signal_to_char(signal_type signal)
{ 
  //return a character representing the 
  //signal's value (for printing).

  char value = '\0';
  switch (signal)
    {
    case True:
      value = '1';
      break;
    case False:
      value = '0';
      break;
    case High_Impedance:
      value = 'Z';
      break;
    case Unknown:
    default:
      value = '?'; //unknown
    } //switch
  return value;
} //signal_to_char

char voltage_to_char(voltage_type voltage)
{ 
//return a character representing the 
//voltage's value (for printing).

  char value = '\0';
  switch (voltage)
    {
    case Low:
      value = 'L';
      break;
    case High:
      value = 'H';
      break;
    case Floating:
    default:
      value = '?'; //unknown
    } //switch
  return value;
} //voltage_to_char


char optical_to_char(optical_type input)
{
  char output = '\0';
  switch(input)
    {
    case UL:
      output = '0';
      break;
    case VL:
      output = '1';
      break;
    case ML:
      output = '2';
      break;
    case L:
      output = '3';
      break;
    case H:
      output = '4';
      break;
    case MH:
      output = '5';
      break;
    case VH:
      output = '6';
      break;
    case UH:
      output = '7';
      break;
    default:
      output = '?';
    } //switch 
  return output;
} //optical_to_int

///////////////////////////////////////////////////////////////////////////////
//end implementation file









